# Code for the Paper "Are Graph Convolutional Networks Fully Exploiting the Graph Structure?"

[Submitted to ICLR2021]

__Please DO NOT change the folder structure of this archive.__

## Models
There is a separate folder for each model, where you will find the specific requirements
that are necessary to run the code, and the instructions to execute the desired tests.
Code for all models will be released upon acceptance.

## Datasets
The "data" folder contains all the datasets in their original form. Node classification
datasets are from <https://linqs.soe.ucsc.edu/data>. While graph
classification, and triangle counting datasets are from:
<https://ls11-www.cs.tu-dortmund.de/staff/morris/graphkerneldatasets>.

## General Requirements
As a general requirement, all the code requires Python 3.6 or greater. The specific
requirements for each model, that can be found in its folder, indicate the packages
(and some times the specific package version number) that need to be installed to run the
code. To preserve your python environment we suggest the creation of a separate
environment for each model (e.g. using virtualenv or conda). The code is primarily built
to be run on CPU.
